#inclib "fbeval"

Enum Boolean
    False = 0
    True = Not False ' equals to -1
End Enum

Enum EvalErrorMessage
    ErrorSuccess = 0    ' no error
    ErrorToken          ' unexpected token
    ErrorBrace          ' unbalanced braces
    ErrorUnknownVar     ' undefined variable
    ErrorUnknownFunc    ' undefined function
End Enum

Type EvalError
    Number      As EvalErrorMessage
    Description As String
    Position    As Integer
    Tag         As String
End Type

Type EvalResult
    Value       As Double
    Success     As Boolean
    Error       As EvalError
End Type

Dim Shared As String CurrentFunction

Declare Sub SetVariable(VarName As String, Value As Double)
Declare Sub UnsetVariable(VarName As String)
Declare Sub ClearVariables()

Declare Sub SetFunction(FuncName As String, Wrapper As Function(argc As Integer, argv() As Double) As Double)
Declare Sub UnsetFunction(FuncName As String)
Declare Sub ClearFunctions()

Declare Function Eval(ExpressionString As String) As EvalResult

